function Rail (arg) {
	this.price = arg.price;
	this.maxMoney = arg.maxMoney * 1;
	this.amount = arg.price.length;
	this.upperLimit = arg.price.indexOf(arg.maxMoney);
	this.stop = arg.stop;

	this.priceWrapDom = null;
	this.priceColDom = null;
	this.railBtnDom = null;
	this.railInnerDom = null;
	this.moneyShowDom = null;
	this.railDom = null;

	this.railInnerWidth = null;
	this.railWrapWidth = null;
	this.itemWidth = null;
	this.colWidth = null;
	this.wrapWidth = null;
	this.beginPointX = null;
	this.stopPointX = null;
	this.currentX = null;
	this.maxDistance = null;
	this.railInnerMaxWidth = null;

	this.currentMoney = null;
	this.aimX = null;
	this.step = null;
	this.mark = false;

	var thisDom = this;
	this.initRailWrap = function () {
		var htmlstr = '<div class="rail-wrap" id="rail-wrap">' +
			'<div class="rail">' +
			'<div class="rail-inner" id="rail-inner"></div>' +
			'</div>' +
			'<div class="rail-btn" id="rail-btn">' +
			'<div class="bg">' +
			'<img class="bg-image" src="../../image/rail-btn.png">' +
			'</div>' +
			'<div class="rail-current-money aui-text-center text-blue" id="money-show"></div>' +
			'</div>' +
			'<div class="rail-price-wrap" id="rail-price-wrap">' +
			'<ul class="rail-price-col" id="rail-price-col">' +
			'</ul>' +
			'</div>' +
			'</div>'
		$api.html('rail-module', htmlstr);
	};
	this.setDoms = function () {
		this.railWrapDom = $api.byId('rail-wrap');
		this.railInnerDom = $api.byId('rail-inner');
		this.priceWrapDom = $api.byId('rail-price-wrap');
		this.priceColDom = $api.byId('rail-price-col');
		this.railBtnDom = $api.byId('rail-btn');
		this.moneyShowDom = $api.byId('money-show');
	};
	this.initPriceCol = function () {
		var railWrapOffset = $api.offset(this.railWrapDom);
		var railInnerOffset = $api.offset(this.railInnerDom);
		// var railBtnOffset = $api.offset(this.railBtnDom);
		var priceWrapOffset = $api.offset(this.priceWrapDom);
		var railInnerWidth = railInnerOffset.w;
		var railWrapWidth = railWrapOffset.w;
		var beginPointX = railWrapOffset.l;
		var wrapWidth = priceWrapOffset.w;
		var colWidth = wrapWidth * (this.amount / (this.amount - 1));
		var itemWidth = wrapWidth / (this.amount - 1);
		$api.css(this.priceColDom, 'width:' + colWidth + 'px; left: -' + (itemWidth / 2) + 'px;');
		this.wrapWidth = wrapWidth;
		this.colWidth = colWidth;
		this.itemWidth = itemWidth;
		this.railWrapWidth = railWrapWidth;
		this.railInnerWidth = railInnerWidth;
		this.beginPointX = beginPointX;
		if (this.upperLimit === 0) {
			this.stopPointX = beginPointX;
			this.maxDistance = 0;
			this.railInnerMaxWidth = railInnerWidth;
		} else {
			this.stopPointX = beginPointX + itemWidth * this.upperLimit;
			this.maxDistance = itemWidth * this.upperLimit;
			this.railInnerMaxWidth = railInnerWidth + this.maxDistance;
		}
	};

	this.initPriceitem = function () {
		var htmlStr = '';
		for (var i = 0; i < this.amount; i++) {
			htmlStr += '<li class="aui-text-center text-gray aui-pull-left" style="width: ' + this.itemWidth + 'px;">' +
				'<p class="rail-ruling">|</p>' +
				'<p class="rail-number">' + this.price[i] + '</p>' +
				'</li>';
		}
		$api.html(this.priceColDom, htmlStr);
	};
	this.initEvent = function () {
		this.railBtnDom.addEventListener('touchstart', this.moveStart, false);
	};
	this.moveStart = function (e) {
		thisDom.mark = true;
		document.addEventListener('touchmove', thisDom.moving, false);
		document.addEventListener('touchend', thisDom.moveEnd, false);
	};
	this.moving = function (e) {
		e.preventDefault();
		var touch = e.targetTouches[0];
		if (thisDom.mark) {
			var finaldX = touch.pageX;
			if (finaldX <= thisDom.beginPointX) {
				$api.css(thisDom.railBtnDom, 'left: 0px;');
				$api.css(thisDom.railInnerDom, 'width: ' + thisDom.railInnerWidth + 'px;');
				finaldX = thisDom.beginPointX;
			} else if (finaldX > thisDom.stopPointX) {
				$api.css(thisDom.railBtnDom, 'left: ' + thisDom.maxDistance + 'px');
				$api.css(thisDom.railInnerDom, 'width: ' + thisDom.railInnerMaxWidth + 'px');
				finaldX = thisDom.stopPointX;
			} else {
				$api.css(thisDom.railBtnDom, 'left: ' + (finaldX - thisDom.beginPointX) + 'px');
				$api.css(thisDom.railInnerDom, 'width: ' + (finaldX - thisDom.beginPointX + thisDom.railInnerWidth) + 'px');
			}
			thisDom.currentX = finaldX;
			$api.addCls(thisDom.moneyShowDom, 'aui-hide');
		}
	};
	this.moveEnd = function (e) {
		e.preventDefault();
		thisDom.mark = false;
		document.removeEventListener('touchmove', thisDom.moving, false);
		document.removeEventListener('touchend', thisDom.moveEnd, false);
		var moveWidth = thisDom.currentX - thisDom.beginPointX;
		if (moveWidth <= 0) {
			thisDom.step = 0;
		} else if (moveWidth === thisDom.maxDistance) {
			thisDom.step = thisDom.upperLimit;
		} else {
			thisDom.step = Math.ceil((thisDom.currentX - thisDom.beginPointX) / thisDom.itemWidth);
		}
		thisDom.aimX = thisDom.step * thisDom.itemWidth + thisDom.beginPointX;
		thisDom.animate();
		thisDom.currentMoney = thisDom.price[thisDom.step];
		if (thisDom.stop) {
			thisDom.stop(thisDom.currentMoney);
		}
	};
	this.showMax = function () {
		this.aimX = this.upperLimit * this.itemWidth + this.beginPointX;
		this.currentX = this.beginPointX;
		this.step = this.upperLimit;
		this.animate();
		this.stop(this.price[this.step]);
	};
	this.animate = function () {
		if (thisDom.currentX < thisDom.aimX) {
			$api.css(thisDom.railBtnDom, 'left: ' + (thisDom.currentX - thisDom.beginPointX + 1) + 'px;');
			$api.css(thisDom.railInnerDom, 'width: ' + (thisDom.currentX - thisDom.beginPointX + thisDom.railInnerWidth) + 'px');
			thisDom.currentX += 1;
			setTimeout(thisDom.animate, 17);
		} else {
			$api.html(thisDom.moneyShowDom, thisDom.price[thisDom.step]);
			$api.removeCls(thisDom.moneyShowDom, 'aui-hide');
		}
	};
	this.initRailWrap();
	this.setDoms();
	this.initPriceCol();
	this.initPriceitem();
	this.showMax();
	this.initEvent();
}
