/**
  * 认证进度
  */
function RenZhengJinDu() {
  this.wrapDom = null;
  this.barDom = null;
  this.progressFlagDoms = null;
  this.progressFlagSequenceDoms = null;
  this.finishSvgDoms = null;
  this.finishSvgHtmlStr = null;
  this.widthSize = null;
  this.stepSize = null;
  this.status = [1, 1, 1, 1];
  this.stepCount = [2, 2, 2, 2];
  this.goal = {
    floor: 0,
    step: 0
  };

  this.main = function() {
    this.initDoms();
    this.initAttrs();
    this.initLayout();
  };

  this.initDoms = function() {
   this.wrapDom = $api.dom(".authentication-progress-bar-wrap");
   this.barDom = $api.dom("authentication-progress-bar");
   this.progressFlagDoms = $api.domAll('.progress-flag');
   this.progressFlagSequenceDoms = $api.domAll('.progress-flag-sequence');
   this.finishSvgDoms = $api.domAll('.icon-size-authentication');
  };

  this.initAttrs = function(argJson) {
    if (argJson) {
      this.goal.floor = argJson.floor;
      this.goal.step = argJson.step;
    }
   this.widthSize.default = {
     wrap: $api.offset(this.wrapDom).w;
     bar: (72 / 690) * $api.offset(this.wrapDom).w;
   };
   this.widthSize.current = {
     bar: this.widthSize.default.bar;
   };
   this.widthSize.goal = {
     bar: null;
   };
   this.status = [1, 1, 1, 1];
   this.stepCount = [2, 2, 2, 2];
   for (var i = 0; i < 4; i++) {
     this.stepSize.push(this.calculateStepSize(this.stepCount[i]));
   }
   this.floorSize = (182 / 690) * this.widthSize.default.wrap;
   this.finishSvgHtmlStr = "<svg class='icon icon-size-dui' aria-hidden='true'>" +
       "<use xlink:href='#icon-dui'></use>" +
     "</svg>";
  };

  this.initLayout = function() {
    this.reset();
    this.change();
  };

  this.change = function() {
    this.setGoalWidth();
    this.move();
  };

  this.setGoalWidth = function() {
    this.widthSize.goal.bar = this.widthSize.default.bar + this.floorSize *　(this.goal.floor - 1) + this.stepSize[this.goal.floor - 1] *　this.goal.step;
  };

  this.reset = function() {
    for (var i = 0; i < 4; i++) {
      try {
        (function(i) {
          $api.removeCls(this.progressFlagDoms[i], 'progress-flag-finish');
          $api.removeCls(this.progressFlagSequenceDoms[i], 'progress-flag-sequence-finish');
          $api.removeCls(this.progressFlagDoms[i], 'aui-hide');
        })(i);
      } catch (e) {}

      try {
        (function(i) {
          $api.removeCls(this.progressFlagDoms[i], 'progress-flag-active');
          $api.removeCls(this.progressFlagSequenceDoms[i], 'progress-flag-sequence-active');
        })(i);
      } catch (e) {}
    }

    $api.remove(this.finishSvgDoms);
  };

  this.move = function() {
    if (this.widthSize.current.bar < this.widthSize.goal.bar) {
      setTimeout(this.animation, 17);
    }
  };

  this.animation = function() {
    this.widthSize.current.bar += 1;
    if (this.widthSize.current.bar < this.widthSize.default.wrap) {
      $api.attr(this.barDom,'width',this.widthSize.current.bar + 'px');
    }
    else {
      this.widthSize.current.bar = this.widthSize.default.wrap;
      $api.attr(this.barDom,'width',this.widthSize.current.bar + 'px');
    }
    this.setStatus();
  };

  this.calculateStepSize = function(num) {
    return (182 / (690 * 3)) * this.widthSize.default.wrap,
  }

  this.setStatus = function() {
    var floor = Math.floor((this.widthSize.current.bar - this.widthSize.default.bar) / this.floorSize);
    if (this.status[floor]) {
      try {
        $api.addCls(this.progressFlagDoms[floor], 'progress-flag-active');
        $api.addCls(this.progressFlagSequenceDoms[floor], 'progress-flag-sequence-active');
      } catch (e) {}

      try {
        $api.removeCls(this.progressFlagDoms[floor - 1], 'progress-flag-active');
        $api.removeCls(this.progressFlagSequenceDoms[floor - 1], 'progress-flag-sequence-active');
      } catch (e) {}

      try {
        $api.addCls(this.progressFlagDoms[floor - 1], 'aui-hide');
        $api.after(this.progressFlagDoms[floor - 1],this.finishSvgHtmlStr);
      } catch (e) {}

      this.status[floor] -= 1;
    }
  };

  this.go = function(argJson) {
    this.goal.floor = argJson.floor;
    this.goal.step = argJson.step;
    this.change();
  };

  this.main();

  return {
    go: this.go
  };

}
